require "import"

import "android.speech.RecognizerIntent"
import "android.speech.SpeechRecognizer"
import "android.speech.RecognitionListener"
import "android.content.Intent"
import "android.net.Uri"

-- Ensure this variable is properly defined
local autoPunctuationBysurya = ""  -- Set to a default value, such as an empty string

if not service.getEditText() then
    service.asyncSpeak("Text Box Not Found!")
    return false
end

local spokenLanguageBysurya = "ur-PK"
local translatedLanguageBysurya = "ar"
local recordIntent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
recordIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
recordIntent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, spokenLanguageBysurya)
local speechRecord = SpeechRecognizer.createSpeechRecognizer(service)
speechRecord.setRecognitionListener{
    onResults = function(results)
        local spokenText = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION).get(0)

        Http.get("https://translate.google.com/m?sl=auto&hl=" .. translatedLanguageBysurya .. "&q=" .. Uri.encode(spokenText), function(status, result)
            if status == 200 then
                local translatedText = result:match('<div class="result%-container">([^<]+)</div>')
                -- Ensure the translatedText is not nil before concatenation
                if translatedText then
                    service.insertText(service.getEditText(), translatedText .. autoPunctuationBysurya)
                    service.speak(translatedText)
                else
                    service.asyncSpeak("Translation Error!")
                end
            else
                service.asyncSpeak("HTTP Request Error!")
            end
        end)
        speechRecord.destroy()
    end,
    onError = function()
        speechRecord.destroy()
        service.asyncSpeak("I Did Not Understand Your Message!")
    end
}

speechRecord.startListening(recordIntent)